initdb.sh 31.5 KB
Newer Older
1
#!@SHELL@
M
 
Marc G. Fournier 已提交
2 3
#-------------------------------------------------------------------------
#
P
Peter Eisentraut 已提交
4
# initdb creates (initializes) a PostgreSQL database cluster (site,
5
# instance, installation, whatever).  A database cluster is a
P
Peter Eisentraut 已提交
6
# collection of PostgreSQL databases all managed by the same postmaster.
M
 
Marc G. Fournier 已提交
7
#
8 9
# To create the database cluster, we create the directory that contains
# all its data, create the files that hold the global tables, create
10 11
# a few other control files for it, and create two databases: the
# template0 and template1 databases.
M
 
Marc G. Fournier 已提交
12
#
13 14 15 16
# The template databases are ordinary PostgreSQL databases.  template0
# is never supposed to change after initdb, whereas template1 can be
# changed to add site-local standard data.  Either one can be copied
# to produce a new database.
M
 
Marc G. Fournier 已提交
17
#
18 19 20 21 22 23 24
# To create template1, we run the postgres (backend) program in bootstrap
# mode and feed it data from the postgres.bki library file.  After this
# initial bootstrap phase, some additional stuff is created by normal
# SQL commands fed to a standalone backend.  Those commands are just
# embedded into this script (yeah, it's ugly).
#
# template0 is made just by copying the completed template1.
M
 
Marc G. Fournier 已提交
25 26
#
#
B
Bruce Momjian 已提交
27
# Portions Copyright (c) 1996-2002, PostgreSQL Global Development Group
28
# Portions Copyright (c) 1994, Regents of the University of California
M
 
Marc G. Fournier 已提交
29
#
B
Bruce Momjian 已提交
30
# $Header: /cvsroot/pgsql/src/bin/initdb/Attic/initdb.sh,v 1.156 2002/06/20 20:29:41 momjian Exp $
B
Bruce Momjian 已提交
31 32 33
#
#-------------------------------------------------------------------------

34 35 36 37 38

##########################################################################
#
# INITIALIZATION

39
exit_nicely(){
B
Bruce Momjian 已提交
40
    stty echo > /dev/null 2>&1
41 42
    echo 1>&2
    echo "$CMDNAME failed." 1>&2
43
    if [ "$noclean" != yes ]; then
44
        if [ "$made_new_pgdata" = yes ]; then
45 46
            echo "Removing $PGDATA." 1>&2
            rm -rf "$PGDATA" || echo "Failed." 1>&2
47
        fi
B
Bruce Momjian 已提交
48
    else
49
        echo "Data directory $PGDATA will not be removed at user's request." 1>&2
B
Bruce Momjian 已提交
50 51 52 53
    fi
    exit 1
}

54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73
pg_getlocale(){
    arg=$1
    unset ret

    for var in "PGLC_$arg" PGLOCALE LC_ALL "LC_$arg" LANG; do
        varset=`eval echo '${'"$var"'+set}'`
        varval=`eval echo '$'"$var"`
        if test "$varset" = set; then
            ret=$varval
            break
        fi
    done

    if test "${ret+set}" != set; then
        ret=C
    fi

    echo "$ret"
}

B
Bruce Momjian 已提交
74 75 76

CMDNAME=`basename $0`

77
# Placed here during build
78 79
VERSION='@VERSION@'
bindir='@bindir@'
80 81
# Note that "datadir" is not the directory we're initializing, it's
# merely how Autoconf names PREFIX/share.
82
datadir='@datadir@'
83
# as set by configure --enable-multibyte[=XXX].
84
MULTIBYTE='@MULTIBYTE@'
85

P
Peter Eisentraut 已提交
86 87 88 89 90 91 92 93 94 95 96 97

# Check for echo -n vs echo \c
if echo '\c' | grep -s c >/dev/null 2>&1
then
    ECHO_N="echo -n"
    ECHO_C=""
else
    ECHO_N="echo"
    ECHO_C='\c'
fi


B
Bruce Momjian 已提交
98 99 100
#
# Find out where we're located
#
101 102
if echo "$0" | grep '/' > /dev/null 2>&1 
then
B
Bruce Momjian 已提交
103
        # explicit dir name given
P
Peter Eisentraut 已提交
104
        self_path=`echo $0 | sed 's,/[^/]*$,,'`       # (dirname command is not portable)
B
Bruce Momjian 已提交
105 106
else
        # look for it in PATH ('which' command is not portable)
B
Bruce Momjian 已提交
107 108
        for dir in `echo "$PATH" | sed 's/:/ /g'`
	do
B
Bruce Momjian 已提交
109 110
                # empty entry in path means current dir
                [ -z "$dir" ] && dir='.'
111
                if [ -f "$dir/$CMDNAME" ]
B
Bruce Momjian 已提交
112
		then
P
Peter Eisentraut 已提交
113
                        self_path="$dir"
B
Bruce Momjian 已提交
114 115 116 117 118
                        break
                fi
        done
fi

P
Peter Eisentraut 已提交
119 120 121 122 123 124 125 126 127

# Check for right version of backend.  First we check for an
# executable in the same directory is this initdb script (presuming
# the above code worked).  Then we fall back to the hard-wired bindir.
# We do it in this order because during upgrades users might move
# their trees to backup places, so $bindir might be inaccurate.

if [ x"$self_path" != x"" ] \
  && [ -x "$self_path/postgres" ] \
128
  && [ x"`$self_path/postgres -V 2>/dev/null`" = x"postgres (PostgreSQL) $VERSION" ]
P
Peter Eisentraut 已提交
129 130 131
then
    PGPATH=$self_path
elif [ -x "$bindir/postgres" ]; then
132
    if [ x"`$bindir/postgres -V 2>/dev/null`" = x"postgres (PostgreSQL) $VERSION" ]
P
Peter Eisentraut 已提交
133 134 135
    then
        PGPATH=$bindir
    else
136 137 138 139 140 141 142 143 144 145 146 147 148
        # Maybe there was an error message?
        errormsg=`$bindir/postgres -V 2>&1 >/dev/null`
      (
        echo "The program "
        echo "    '$bindir/postgres'"
        echo "needed by $CMDNAME does not belong to PostgreSQL version $VERSION, or"
        echo "there may be a configuration problem."
        if test x"$errormsg" != x""; then
            echo
            echo "This was the error message issued by that program:"
            echo "$errormsg"
        fi
      ) 1>&2
P
Peter Eisentraut 已提交
149 150 151
        exit 1
    fi
else
152 153
    echo "The program 'postgres' is needed by $CMDNAME but was not found in" 1>&2
    echo "the directory '$bindir'.  Check your installation." 1>&2
P
Peter Eisentraut 已提交
154
    exit 1
155 156
fi

P
Peter Eisentraut 已提交
157 158 159 160

# Now we can assume that 'pg_id' belongs to the same version as the
# verified 'postgres' in the same directory.
if [ ! -x "$PGPATH/pg_id" ]; then
161 162
    echo "The program 'pg_id' is needed by $CMDNAME but was not found in" 1>&2
    echo "the directory '$PGPATH'.  Check your installation." 1>&2
P
Peter Eisentraut 已提交
163 164
    exit 1
fi
B
Bruce Momjian 已提交
165

166 167 168

EffectiveUser=`$PGPATH/pg_id -n -u`
if [ -z "$EffectiveUser" ]; then
169
    echo "$CMDNAME: could not determine current user name" 1>&2
170 171 172 173 174
    exit 1
fi

if [ `$PGPATH/pg_id -u` -eq 0 ]
then
175 176
    echo "You cannot run $CMDNAME as root. Please log in (using, e.g., 'su')" 1>&2
    echo "as the (unprivileged) user that will own the server process." 1>&2
177 178 179
    exit 1
fi

180

181 182
short_version=`echo $VERSION | sed -e 's!^\([0-9][0-9]*\.[0-9][0-9]*\).*!\1!'`
if [ x"$short_version" = x"" ] ; then
183
  echo "$CMDNAME: bug: version number has wrong format" 1>&2
184 185
  exit 1
fi
186

187 188 189 190 191

##########################################################################
#
# COMMAND LINE OPTIONS

B
Bruce Momjian 已提交
192 193 194 195
# 0 is the default (non-)encoding
MULTIBYTEID=0

# Set defaults:
196 197 198
debug=
noclean=
show_setting=
B
Bruce Momjian 已提交
199 200 201 202 203

# Note: There is a single compelling reason that the name of the database
#       superuser be the same as the Unix user owning the server process:
#       The single user postgres backend will only connect as the database
#       user with the same name as the Unix user running it. That's
204
#       a security measure.
205
POSTGRES_SUPERUSERNAME="$EffectiveUser"
B
Bruce Momjian 已提交
206

207
while [ "$#" -gt 0 ]
B
Bruce Momjian 已提交
208 209 210 211 212 213
do
    case "$1" in
        --help|-\?)
                usage=t
                break
                ;;
214
        --version|-V)
215 216 217
                echo "initdb (PostgreSQL) $VERSION"
                exit 0
                ;;
B
Bruce Momjian 已提交
218
        --debug|-d)
219
                debug=yes
B
Bruce Momjian 已提交
220 221
                echo "Running with debug mode on."
                ;;
222
        --show|-s)
223
        	show_setting=yes
224
        	;;        
B
Bruce Momjian 已提交
225
        --noclean|-n)
226
                noclean=yes
B
Bruce Momjian 已提交
227 228
                echo "Running with noclean mode on. Mistakes will not be cleaned up."
                ;;
229 230 231
# The name of the database superuser. Can be freely changed.
        --username|-U)
                POSTGRES_SUPERUSERNAME="$2"
B
Bruce Momjian 已提交
232
                shift;;
233 234
        --username=*)
                POSTGRES_SUPERUSERNAME=`echo $1 | sed 's/^--username=//'`
B
Bruce Momjian 已提交
235
                ;;
236 237
        -U*)
                POSTGRES_SUPERUSERNAME=`echo $1 | sed 's/^-U//'`
B
Bruce Momjian 已提交
238 239
                ;;
# The default password of the database superuser.
P
Peter Eisentraut 已提交
240 241 242
# Make initdb prompt for the default password of the database superuser.
        --pwprompt|-W)
                PwPrompt=1
B
Bruce Momjian 已提交
243 244 245 246 247 248 249 250 251 252 253 254
                ;;
# Directory where to install the data. No default, unless the environment
# variable PGDATA is set.
        --pgdata|-D)
                PGDATA="$2"
                shift;;
        --pgdata=*)
                PGDATA=`echo $1 | sed 's/^--pgdata=//'`
                ;;
        -D*)
                PGDATA=`echo $1 | sed 's/^-D//'`
                ;;
255
# The directory where the .bki input files are stored. Normally
256 257 258
# they are in PREFIX/share and this option should be unnecessary.
        -L)
                datadir="$2"
B
Bruce Momjian 已提交
259 260
                shift;;
        -L*)
261
                datadir=`echo $1 | sed 's/^-L//'`
B
Bruce Momjian 已提交
262 263 264
                ;;
# The encoding of the template1 database. Defaults to what you chose
# at configure time. (see above)
265
        --encoding|-E)
B
Bruce Momjian 已提交
266 267
                MULTIBYTE="$2"
                shift;;
P
Peter Eisentraut 已提交
268 269
        --encoding=*)
                MULTIBYTE=`echo $1 | sed 's/^--encoding=//'`
B
Bruce Momjian 已提交
270
                ;;
271 272
        -E*)
                MULTIBYTE=`echo $1 | sed 's/^-E//'`
B
Bruce Momjian 已提交
273
                ;;
274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321
# Locale flags
        --locale)
                PGLOCALE="$2"
                shift;;
        --locale=*)
                PGLOCALE=`echo $1 | sed 's/^[^=]*=//'`
                ;;
        --no-locale)
                PGLOCALE=C
                ;;

        --lc-collate)
                PGLC_COLLATE=$2
                shift;;
        --lc-collate=*)
                PGLC_COLLATE=`echo $1 | sed 's/^[^=]*=//'`
                ;;
        --lc-ctype)
                PGLC_CTYPE=$2
                shift;;
        --lc-ctype=*)
                PGLC_CTYPE=`echo $1 | sed 's/^[^=]*=//'`
                ;;
        --lc-messages)
                PGLC_MESSAGES=$2
                shift;;
        --lc-messages=*)
                PGLC_MESSAGES=`echo $1 | sed 's/^[^=]*=//'`
                ;;
        --lc-monetary)
                PGLC_MONETARY=$2
                shift;;
        --lc-monetary=*)
                PGLC_MONETARY=`echo $1 | sed 's/^[^=]*=//'`
                ;;
        --lc-numeric)
                PGLC_NUMERIC=$2
                shift;;
        --lc-numeric=*)
                PGLC_NUMERIC=`echo $1 | sed 's/^[^=]*=//'`
                ;;
        --lc-time)
                PGLC_TIME=$2
                shift;;
        --lc-time=*)
                PGLC_TIME=`echo $1 | sed 's/^[^=]*=//'`
                ;;

P
Peter Eisentraut 已提交
322 323
	-*)
		echo "$CMDNAME: invalid option: $1"
324
		echo "Try '$CMDNAME --help' for more information."
P
Peter Eisentraut 已提交
325 326
		exit 1
		;;
327 328

# Non-option argument specifies data directory
B
Bruce Momjian 已提交
329
        *)
P
Peter Eisentraut 已提交
330
                PGDATA=$1
B
Bruce Momjian 已提交
331 332 333 334 335
                ;;
    esac
    shift
done

P
Peter Eisentraut 已提交
336
if [ "$usage" ]; then
337
    echo "$CMDNAME initializes a PostgreSQL database cluster."
338 339 340 341 342
    echo
    echo "Usage:"
    echo "  $CMDNAME [options] datadir"
    echo
    echo "Options:"
343
    echo " [-D, --pgdata] DATADIR       Location for this database cluster"
344 345
    echo "  -W, --pwprompt              Prompt for a password for the new superuser"
    if [ -n "$MULTIBYTE" ] ; then 
346
        echo "  -E, --encoding ENCODING     Set default encoding for new databases"
347
    fi
348 349 350 351 352 353 354
    echo "  --locale LOCALE             Initialize database cluster with given locale"
    echo "  --lc-collate, --lc-ctype, --lc-messages LOCALE"
    echo "  --lc-monetary, --lc-numeric, --lc-time LOCALE"
    echo "                              Initialize database cluster with given locale"
    echo "                              in the respective category"
    echo "                              (default taken from environment)"
    echo "  --no-locale                 Equivalent to --locale=C"
355
    echo "  -U, --username NAME         Database superuser name"
356
    echo "Less commonly used options: "
357
    echo "  -L DIRECTORY                Where to find the input files"
358 359 360 361 362
    echo "  -d, --debug                 Generate lots of debugging output"
    echo "  -n, --noclean               Do not clean up after errors"
    echo
    echo "Report bugs to <pgsql-bugs@postgresql.org>."
    exit 0
B
Bruce Momjian 已提交
363 364 365 366 367 368
fi

#-------------------------------------------------------------------------
# Resolve the multibyte encoding name
#-------------------------------------------------------------------------

369 370
if [ "$MULTIBYTE" ]
then
T
Tatsuo Ishii 已提交
371
	MULTIBYTEID=`$PGPATH/pg_encoding -b $MULTIBYTE`
372
        if [ "$?" -ne 0 ]
B
Bruce Momjian 已提交
373
	then
374
              (
P
Peter Eisentraut 已提交
375 376 377 378
                echo "$CMDNAME: pg_encoding failed"
                echo
                echo "Perhaps you did not configure PostgreSQL for multibyte support or"
                echo "the program was not successfully installed."
379
              ) 1>&2
B
Bruce Momjian 已提交
380 381
                exit 1
        fi
382 383
	if [ -z "$MULTIBYTEID" ]
	then
T
Tatsuo Ishii 已提交
384
		echo "$CMDNAME: $MULTIBYTE is not a valid backend encoding name" 1>&2
385
		exit 1
B
Bruce Momjian 已提交
386 387 388 389 390 391 392 393
	fi
fi


#-------------------------------------------------------------------------
# Make sure he told us where to build the database system
#-------------------------------------------------------------------------

394 395
if [ -z "$PGDATA" ]
then
396
  (
B
Bruce Momjian 已提交
397
    echo "$CMDNAME: You must identify where the the data for this database"
398
    echo "system will reside.  Do this with either a -D invocation"
B
Bruce Momjian 已提交
399
    echo "option or a PGDATA environment variable."
400
  ) 1>&2
B
Bruce Momjian 已提交
401 402 403 404 405 406 407 408
    exit 1
fi


#-------------------------------------------------------------------------
# Find the input files
#-------------------------------------------------------------------------

409 410
POSTGRES_BKI="$datadir"/postgres.bki
POSTGRES_DESCR="$datadir"/postgres.description
B
Bruce Momjian 已提交
411

412
PG_HBA_SAMPLE="$datadir"/pg_hba.conf.sample
413
PG_IDENT_SAMPLE="$datadir"/pg_ident.conf.sample
414
POSTGRESQL_CONF_SAMPLE="$datadir"/postgresql.conf.sample
B
Bruce Momjian 已提交
415

416
if [ "$show_setting" = yes ] || [ "$debug" = yes ]
417
then
418
  (
419
    echo
420
    echo "initdb variables:"
421
    for var in PGDATA datadir PGPATH MULTIBYTE MULTIBYTEID \
422
        POSTGRES_SUPERUSERNAME POSTGRES_BKI \
423
        POSTGRES_DESCR POSTGRESQL_CONF_SAMPLE \
424
	PG_HBA_SAMPLE PG_IDENT_SAMPLE ; do
425 426
        eval "echo '  '$var=\$$var"
    done
427
  ) 1>&2
428 429 430 431
fi

if [ "$show_setting" = yes ] ; then
    exit 0
432 433
fi

434 435
for PREREQ_FILE in "$POSTGRES_BKI" "$POSTGRES_DESCR" \
    "$PG_HBA_SAMPLE" "$PG_IDENT_SAMPLE" "$POSTGRESQL_CONF_SAMPLE"
B
Bruce Momjian 已提交
436
do
437
    if [ ! -f "$PREREQ_FILE" ] ; then
438
      (
B
Bruce Momjian 已提交
439 440
        echo "$CMDNAME does not find the file '$PREREQ_FILE'."
        echo "This means you have a corrupted installation or identified the"
441
        echo "wrong directory with the -L invocation option."
442
      ) 1>&2
B
Bruce Momjian 已提交
443 444 445 446
        exit 1
    fi
done

447 448
for file in "$POSTGRES_BKI"
do
P
Peter Eisentraut 已提交
449
     if [ x"`sed 1q $file`" != x"# PostgreSQL $short_version" ]; then
450
       (
P
Peter Eisentraut 已提交
451 452 453
         echo "The input file '$file' needed by $CMDNAME does not"
         echo "belong to PostgreSQL $VERSION.  Check your installation or specify the"
         echo "correct path using the -L option."
454
       ) 1>&2
P
Peter Eisentraut 已提交
455 456 457 458
         exit 1
     fi
done

B
Bruce Momjian 已提交
459

B
Bruce Momjian 已提交
460
trap 'echo "Caught signal." ; exit_nicely' 1 2 3 15
B
Bruce Momjian 已提交
461

462
# Let's go
463 464
echo "The files belonging to this database system will be owned by user \"$EffectiveUser\"."
echo "This user must also own the server process."
465
echo
B
Bruce Momjian 已提交
466

467 468
TAB='	'

469 470 471 472 473
if test x`pg_getlocale CTYPE` = x`pg_getlocale COLLATE` \
   && test x`pg_getlocale CTYPE` = x`pg_getlocale TIME` \
   && test x`pg_getlocale CTYPE` = x`pg_getlocale NUMERIC` \
   && test x`pg_getlocale CTYPE` = x`pg_getlocale MONETARY` \
   && test x`pg_getlocale CTYPE` = x`pg_getlocale MESSAGES`
474 475 476 477 478 479 480 481 482
then
    echo "The database cluster will be initialized with locale `pg_getlocale CTYPE`."
else
    echo "The database cluster will be initialized with locales:"
    echo "    COLLATE:  `pg_getlocale COLLATE`${TAB}CTYPE:   `pg_getlocale CTYPE`${TAB}MESSAGES: `pg_getlocale MESSAGES`"
    echo "    MONETARY: `pg_getlocale MONETARY`${TAB}NUMERIC: `pg_getlocale NUMERIC`${TAB}TIME:     `pg_getlocale TIME`"
fi

# (Be sure to maintain the correspondence with locale_is_like_safe() in selfuncs.c.)
483
if test x`pg_getlocale COLLATE` != xC && test x`pg_getlocale COLLATE` != xPOSIX; then
484 485 486 487 488 489 490
    echo "This locale setting will prevent the use of indexes for pattern matching"
    echo "operations.  If that is a concern, rerun $CMDNAME with the collation order"
    echo "set to \"C\".  For more information see the Administrator's Guide."
fi
echo


491 492 493
##########################################################################
#
# CREATE DATABASE DIRECTORY
M
 
Marc G. Fournier 已提交
494 495 496 497

# umask must disallow access to group, other for files and dirs
umask 077

498 499 500
# find out if directory is empty
pgdata_contents=`ls -A "$PGDATA" 2>/dev/null`
if [ x"$pgdata_contents" != x ]
501
then
502 503 504 505 506 507 508
    (
      echo "$CMDNAME: The directory $PGDATA exists but is not empty."
      echo "If you want to create a new database system, either remove or empty"
      echo "the directory $PGDATA or run initdb with"
      echo "an argument other than $PGDATA."
    ) 1>&2
    exit 1
M
 
Marc G. Fournier 已提交
509
else
510
    if [ ! -d "$PGDATA" ]; then
511
        $ECHO_N "creating directory $PGDATA... "$ECHO_C
512
        mkdir -p "$PGDATA" >/dev/null 2>&1 || mkdir "$PGDATA" || exit_nicely
513
        made_new_pgdata=yes
514
    else
515
        $ECHO_N "Fixing permissions on existing directory $PGDATA... "$ECHO_C
516
	chmod go-rwx "$PGDATA" || exit_nicely
M
 
Marc G. Fournier 已提交
517
    fi
518
    echo "ok"
519

520 521
    if [ ! -d "$PGDATA"/base ]
	then
522
        $ECHO_N "creating directory $PGDATA/base... "$ECHO_C
523
        mkdir "$PGDATA"/base || exit_nicely
524
	echo "ok"
M
 
Marc G. Fournier 已提交
525
    fi
526 527
    if [ ! -d "$PGDATA"/global ]
    then
528
        $ECHO_N "creating directory $PGDATA/global... "$ECHO_C
529
        mkdir "$PGDATA"/global || exit_nicely
530
	echo "ok"
531
    fi
532
    if [ ! -d "$PGDATA"/pg_xlog ]
B
Bruce Momjian 已提交
533
    then
534
        $ECHO_N "creating directory $PGDATA/pg_xlog... "$ECHO_C
535
        mkdir "$PGDATA"/pg_xlog || exit_nicely
536
	echo "ok"
537
    fi
538 539 540 541 542 543
    if [ ! -d "$PGDATA"/pg_clog ]
    then
        $ECHO_N "creating directory $PGDATA/pg_clog... "$ECHO_C
        mkdir "$PGDATA"/pg_clog || exit_nicely
	echo "ok"
    fi
M
 
Marc G. Fournier 已提交
544 545
fi

546 547 548

##########################################################################
#
549
# RUN BKI SCRIPT IN BOOTSTRAP MODE TO CREATE TEMPLATE1
M
 
Marc G. Fournier 已提交
550

551 552
# common backend options
PGSQL_OPT="-F -D$PGDATA"
M
 
Marc G. Fournier 已提交
553

554
if [ "$debug" = yes ]
555
then
556
    BACKEND_TALK_ARG="-d 5"
557 558
else
    PGSQL_OPT="$PGSQL_OPT -o /dev/null"
M
 
Marc G. Fournier 已提交
559 560 561
fi


562 563 564 565
$ECHO_N "creating template1 database in $PGDATA/base/1... "$ECHO_C

rm -rf "$PGDATA"/base/1 || exit_nicely
mkdir "$PGDATA"/base/1 || exit_nicely
M
 
Marc G. Fournier 已提交
566

567 568 569
# Top level PG_VERSION is checked by bootstrapper, so make it first
echo "$short_version" > "$PGDATA/PG_VERSION" || exit_nicely

570 571 572
cat "$POSTGRES_BKI" \
| sed -e "s/POSTGRES/$POSTGRES_SUPERUSERNAME/g" \
      -e "s/ENCODING/$MULTIBYTEID/g" \
573 574 575 576 577 578 579 580 581
| 
(
  LC_COLLATE=`pg_getlocale COLLATE`
  LC_CTYPE=`pg_getlocale CTYPE`
  export LC_COLLATE
  export LC_CTYPE
  unset LC_ALL
  "$PGPATH"/postgres -boot -x1 $PGSQL_OPT $BACKEND_TALK_ARG template1
) \
582
|| exit_nicely
M
 
Marc G. Fournier 已提交
583

584 585
# Make the per-database PGVERSION for template1 only after init'ing it
echo "$short_version" > "$PGDATA/base/1/PG_VERSION" || exit_nicely
M
 
Marc G. Fournier 已提交
586

587 588
echo "ok"

589 590
##########################################################################
#
591
# CREATE CONFIG FILES
592

593 594
$ECHO_N "creating configuration files... "$ECHO_C

595 596
cp "$PG_HBA_SAMPLE" "$PGDATA"/pg_hba.conf              || exit_nicely
cp "$PG_IDENT_SAMPLE" "$PGDATA"/pg_ident.conf          || exit_nicely
597 598 599 600 601 602 603 604 605 606 607 608 609
(
  cat "$POSTGRESQL_CONF_SAMPLE"
  echo
  echo
  echo "#"
  echo "#	Locale settings"
  echo "#"
  echo "# (initialized by initdb -- may be changed)"
  for cat in MESSAGES MONETARY NUMERIC TIME; do
    echo "LC_$cat = '`pg_getlocale $cat`'"
  done
) > "$PGDATA"/postgresql.conf || exit_nicely

610 611
chmod 0600 "$PGDATA"/pg_hba.conf "$PGDATA"/pg_ident.conf \
	"$PGDATA"/postgresql.conf
M
 
Marc G. Fournier 已提交
612

613 614
echo "ok"

615 616 617
##########################################################################
#
# CREATE VIEWS and other things
618 619 620 621 622
#
# NOTE: because here we are driving a standalone backend (not psql), we must
# follow the standalone backend's convention that commands end at a newline.
# To break an SQL command across lines in this script, backslash-escape all
# internal newlines in the command.
623

624
PGSQL_OPT="$PGSQL_OPT -O -c search_path=pg_catalog"
M
 
Marc G. Fournier 已提交
625

626
$ECHO_N "initializing pg_shadow... "$ECHO_C
M
 
Marc G. Fournier 已提交
627

628 629
"$PGPATH"/postgres $PGSQL_OPT template1 >/dev/null <<EOF
-- Create a trigger so that direct updates to pg_shadow will be written
B
Bruce Momjian 已提交
630
-- to the flat password/group files pg_pwd and pg_group
631
CREATE TRIGGER pg_sync_pg_pwd AFTER INSERT OR UPDATE OR DELETE ON pg_shadow \
B
Bruce Momjian 已提交
632 633 634
FOR EACH ROW EXECUTE PROCEDURE update_pg_pwd_and_pg_group();
CREATE TRIGGER pg_sync_pg_group AFTER INSERT OR UPDATE OR DELETE ON pg_group \
FOR EACH ROW EXECUTE PROCEDURE update_pg_pwd_and_pg_group();
635 636 637 638 639 640 641
-- needs to be done before alter user, because alter user checks that
-- pg_shadow is secure ...
REVOKE ALL on pg_shadow FROM public;
EOF
if [ "$?" -ne 0 ]; then
    exit_nicely
fi
642
echo "ok"
643

P
Peter Eisentraut 已提交
644 645 646
# set up password
if [ "$PwPrompt" ]; then
    $ECHO_N "Enter new superuser password: "$ECHO_C
B
Bruce Momjian 已提交
647
    stty -echo > /dev/null 2>&1
P
Peter Eisentraut 已提交
648
    read FirstPw
B
Bruce Momjian 已提交
649
    stty echo > /dev/null 2>&1
P
Peter Eisentraut 已提交
650 651
    echo
    $ECHO_N "Enter it again: "$ECHO_C
B
Bruce Momjian 已提交
652
    stty -echo > /dev/null 2>&1
P
Peter Eisentraut 已提交
653
    read SecondPw
B
Bruce Momjian 已提交
654
    stty echo > /dev/null 2>&1
P
Peter Eisentraut 已提交
655 656
    echo
    if [ "$FirstPw" != "$SecondPw" ]; then
657
        echo "Passwords didn't match." 1>&2
P
Peter Eisentraut 已提交
658 659
        exit_nicely
    fi
660
    $ECHO_N "setting password... "$ECHO_C
661 662 663 664 665 666
    "$PGPATH"/postgres $PGSQL_OPT template1 >/dev/null <<EOF
	ALTER USER "$POSTGRES_SUPERUSERNAME" WITH PASSWORD '$FirstPw';
EOF
    if [ "$?" -ne 0 ]; then
	exit_nicely
    fi
667
    if [ ! -f "$PGDATA"/global/pg_pwd ]; then
668
        echo
669
        echo "The password file wasn't generated. Please report this problem." 1>&2
P
Peter Eisentraut 已提交
670 671
        exit_nicely
    fi
B
Bruce Momjian 已提交
672 673 674 675 676
    if [ ! -f "$PGDATA"/global/pg_group ]; then
        echo
        echo "The group file wasn't generated. Please report this problem." 1>&2
        exit_nicely
    fi
677
    echo "ok"
P
Peter Eisentraut 已提交
678 679
fi

680

681
$ECHO_N "enabling unlimited row size for system tables... "$ECHO_C
682

683 684
"$PGPATH"/postgres $PGSQL_OPT template1 >/dev/null <<EOF
ALTER TABLE pg_attrdef CREATE TOAST TABLE;
685
ALTER TABLE pg_database CREATE TOAST TABLE;
686
ALTER TABLE pg_description CREATE TOAST TABLE;
687
ALTER TABLE pg_group CREATE TOAST TABLE;
688 689 690
ALTER TABLE pg_proc CREATE TOAST TABLE;
ALTER TABLE pg_relcheck CREATE TOAST TABLE;
ALTER TABLE pg_rewrite CREATE TOAST TABLE;
691
ALTER TABLE pg_shadow CREATE TOAST TABLE;
692 693 694 695 696
ALTER TABLE pg_statistic CREATE TOAST TABLE;
EOF
if [ "$?" -ne 0 ]; then
    exit_nicely
fi
697
echo "ok"
698 699


700
$ECHO_N "creating system views... "$ECHO_C
701

702 703 704 705 706 707 708 709 710 711 712
"$PGPATH"/postgres $PGSQL_OPT template1 >/dev/null <<EOF

CREATE VIEW pg_user AS \
    SELECT \
        usename, \
        usesysid, \
        usecreatedb, \
        usetrace, \
        usesuper, \
        usecatupd, \
        '********'::text as passwd, \
713 714
        valuntil, \
        useconfig \
715 716 717 718
    FROM pg_shadow;

CREATE VIEW pg_rules AS \
    SELECT \
719
        N.nspname AS schemaname, \
720 721
        C.relname AS tablename, \
        R.rulename AS rulename, \
722 723 724
        pg_get_ruledef(R.oid) AS definition \
    FROM (pg_rewrite R JOIN pg_class C ON (C.oid = R.ev_class)) \
        LEFT JOIN pg_namespace N ON (N.oid = C.relnamespace) \
725
    WHERE R.rulename != '_RETURN';
726 727 728

CREATE VIEW pg_views AS \
    SELECT \
729
        N.nspname AS schemaname, \
730 731
        C.relname AS viewname, \
        pg_get_userbyid(C.relowner) AS viewowner, \
732 733
        pg_get_viewdef(C.oid) AS definition \
    FROM pg_class C LEFT JOIN pg_namespace N ON (N.oid = C.relnamespace) \
734 735 736 737 738 739 740 741 742 743 744 745 746 747 748 749 750 751 752 753 754 755 756 757 758 759 760 761 762 763 764 765 766 767 768 769 770 771 772 773 774 775 776 777 778 779 780 781 782 783 784 785 786 787 788 789 790 791 792 793 794 795 796 797 798 799 800 801 802 803 804 805 806
    WHERE C.relkind = 'v';

-- XXX why does pg_tables include sequences?

CREATE VIEW pg_tables AS \
    SELECT \
        C.relname AS tablename, \
        pg_get_userbyid(C.relowner) AS tableowner, \
        C.relhasindex AS hasindexes, \
        C.relhasrules AS hasrules, \
        (C.reltriggers > 0) AS hastriggers \
    FROM pg_class C \
    WHERE C.relkind IN ('r', 's');

CREATE VIEW pg_indexes AS \
    SELECT \
        C.relname AS tablename, \
        I.relname AS indexname, \
        pg_get_indexdef(X.indexrelid) AS indexdef \
    FROM pg_index X, pg_class C, pg_class I \
    WHERE C.relkind = 'r' AND I.relkind = 'i' \
        AND C.oid = X.indrelid \
        AND I.oid = X.indexrelid;

CREATE VIEW pg_stats AS \
    SELECT \
        relname AS tablename, \
        attname AS attname, \
        stanullfrac AS null_frac, \
        stawidth AS avg_width, \
        stadistinct AS n_distinct, \
        CASE 1 \
            WHEN stakind1 THEN stavalues1 \
            WHEN stakind2 THEN stavalues2 \
            WHEN stakind3 THEN stavalues3 \
            WHEN stakind4 THEN stavalues4 \
        END AS most_common_vals, \
        CASE 1 \
            WHEN stakind1 THEN stanumbers1 \
            WHEN stakind2 THEN stanumbers2 \
            WHEN stakind3 THEN stanumbers3 \
            WHEN stakind4 THEN stanumbers4 \
        END AS most_common_freqs, \
        CASE 2 \
            WHEN stakind1 THEN stavalues1 \
            WHEN stakind2 THEN stavalues2 \
            WHEN stakind3 THEN stavalues3 \
            WHEN stakind4 THEN stavalues4 \
        END AS histogram_bounds, \
        CASE 3 \
            WHEN stakind1 THEN stanumbers1[1] \
            WHEN stakind2 THEN stanumbers2[1] \
            WHEN stakind3 THEN stanumbers3[1] \
            WHEN stakind4 THEN stanumbers4[1] \
        END AS correlation \
    FROM pg_class c, pg_attribute a, pg_statistic s \
    WHERE c.oid = s.starelid AND c.oid = a.attrelid \
        AND a.attnum = s.staattnum \
        AND has_table_privilege(c.oid, 'select');

REVOKE ALL on pg_statistic FROM public;

CREATE VIEW pg_stat_all_tables AS \
    SELECT \
            C.oid AS relid, \
            C.relname AS relname, \
            pg_stat_get_numscans(C.oid) AS seq_scan, \
            pg_stat_get_tuples_returned(C.oid) AS seq_tup_read, \
            sum(pg_stat_get_numscans(I.indexrelid)) AS idx_scan, \
            sum(pg_stat_get_tuples_fetched(I.indexrelid)) AS idx_tup_fetch, \
            pg_stat_get_tuples_inserted(C.oid) AS n_tup_ins, \
            pg_stat_get_tuples_updated(C.oid) AS n_tup_upd, \
            pg_stat_get_tuples_deleted(C.oid) AS n_tup_del \
807
    FROM pg_class C LEFT OUTER JOIN \
808 809 810 811 812 813 814 815 816 817 818 819 820 821 822 823 824 825 826 827 828 829 830 831 832 833 834 835
         pg_index I ON C.oid = I.indrelid \
    WHERE C.relkind = 'r' \
    GROUP BY C.oid, C.relname;

CREATE VIEW pg_stat_sys_tables AS \
    SELECT * FROM pg_stat_all_tables \
    WHERE relname ~ '^pg_';

CREATE VIEW pg_stat_user_tables AS \
    SELECT * FROM pg_stat_all_tables \
    WHERE relname !~ '^pg_';

CREATE VIEW pg_statio_all_tables AS \
    SELECT \
            C.oid AS relid, \
            C.relname AS relname, \
            pg_stat_get_blocks_fetched(C.oid) - \
                    pg_stat_get_blocks_hit(C.oid) AS heap_blks_read, \
            pg_stat_get_blocks_hit(C.oid) AS heap_blks_hit, \
            sum(pg_stat_get_blocks_fetched(I.indexrelid) - \
                    pg_stat_get_blocks_hit(I.indexrelid)) AS idx_blks_read, \
            sum(pg_stat_get_blocks_hit(I.indexrelid)) AS idx_blks_hit, \
            pg_stat_get_blocks_fetched(T.oid) - \
                    pg_stat_get_blocks_hit(T.oid) AS toast_blks_read, \
            pg_stat_get_blocks_hit(T.oid) AS toast_blks_hit, \
            pg_stat_get_blocks_fetched(X.oid) - \
                    pg_stat_get_blocks_hit(X.oid) AS tidx_blks_read, \
            pg_stat_get_blocks_hit(X.oid) AS tidx_blks_hit \
836 837 838
    FROM pg_class C LEFT OUTER JOIN \
            pg_index I ON C.oid = I.indrelid LEFT OUTER JOIN \
            pg_class T ON C.reltoastrelid = T.oid LEFT OUTER JOIN \
839
            pg_class X ON T.reltoastidxid = X.oid \
840 841 842 843 844 845 846 847 848 849 850 851 852 853 854 855 856 857 858 859 860 861 862 863 864 865 866 867 868 869 870 871 872 873 874 875 876 877 878 879 880 881 882 883 884 885 886 887 888 889 890 891 892 893 894 895 896 897 898 899 900 901 902 903 904 905 906 907 908 909 910 911 912 913 914 915 916 917 918 919 920 921 922 923 924 925 926 927 928 929 930 931 932 933 934 935 936 937 938 939 940 941 942 943 944 945 946
    WHERE C.relkind = 'r' \
    GROUP BY C.oid, C.relname, T.oid, X.oid;

CREATE VIEW pg_statio_sys_tables AS \
    SELECT * FROM pg_statio_all_tables \
    WHERE relname ~ '^pg_';

CREATE VIEW pg_statio_user_tables AS \
    SELECT * FROM pg_statio_all_tables \
    WHERE relname !~ '^pg_';

CREATE VIEW pg_stat_all_indexes AS \
    SELECT \
            C.oid AS relid, \
            I.oid AS indexrelid, \
            C.relname AS relname, \
            I.relname AS indexrelname, \
            pg_stat_get_numscans(I.oid) AS idx_scan, \
            pg_stat_get_tuples_returned(I.oid) AS idx_tup_read, \
            pg_stat_get_tuples_fetched(I.oid) AS idx_tup_fetch \
    FROM pg_class C, \
            pg_class I, \
            pg_index X \
    WHERE C.relkind = 'r' AND \
            X.indrelid = C.oid AND \
            X.indexrelid = I.oid;

CREATE VIEW pg_stat_sys_indexes AS \
    SELECT * FROM pg_stat_all_indexes \
    WHERE relname ~ '^pg_';

CREATE VIEW pg_stat_user_indexes AS \
    SELECT * FROM pg_stat_all_indexes \
    WHERE relname !~ '^pg_';

CREATE VIEW pg_statio_all_indexes AS \
    SELECT \
            C.oid AS relid, \
            I.oid AS indexrelid, \
            C.relname AS relname, \
            I.relname AS indexrelname, \
            pg_stat_get_blocks_fetched(I.oid) - \
                    pg_stat_get_blocks_hit(I.oid) AS idx_blks_read, \
            pg_stat_get_blocks_hit(I.oid) AS idx_blks_hit \
    FROM pg_class C, \
            pg_class I, \
            pg_index X \
    WHERE C.relkind = 'r' AND \
            X.indrelid = C.oid AND \
            X.indexrelid = I.oid;

CREATE VIEW pg_statio_sys_indexes AS \
    SELECT * FROM pg_statio_all_indexes \
    WHERE relname ~ '^pg_';

CREATE VIEW pg_statio_user_indexes AS \
    SELECT * FROM pg_statio_all_indexes \
    WHERE relname !~ '^pg_';

CREATE VIEW pg_statio_all_sequences AS \
    SELECT \
            C.oid AS relid, \
            C.relname AS relname, \
            pg_stat_get_blocks_fetched(C.oid) - \
                    pg_stat_get_blocks_hit(C.oid) AS blks_read, \
            pg_stat_get_blocks_hit(C.oid) AS blks_hit \
    FROM pg_class C \
    WHERE C.relkind = 'S';

CREATE VIEW pg_statio_sys_sequences AS \
    SELECT * FROM pg_statio_all_sequences \
    WHERE relname ~ '^pg_';

CREATE VIEW pg_statio_user_sequences AS \
    SELECT * FROM pg_statio_all_sequences \
    WHERE relname !~ '^pg_';

CREATE VIEW pg_stat_activity AS \
    SELECT \
            D.oid AS datid, \
            D.datname AS datname, \
            pg_stat_get_backend_pid(S.backendid) AS procpid, \
            pg_stat_get_backend_userid(S.backendid) AS usesysid, \
            U.usename AS usename, \
            pg_stat_get_backend_activity(S.backendid) AS current_query \
    FROM pg_database D, \
            (SELECT pg_stat_get_backend_idset() AS backendid) AS S, \
            pg_shadow U \
    WHERE pg_stat_get_backend_dbid(S.backendid) = D.oid AND \
            pg_stat_get_backend_userid(S.backendid) = U.usesysid;

CREATE VIEW pg_stat_database AS \
    SELECT \
            D.oid AS datid, \
            D.datname AS datname, \
            pg_stat_get_db_numbackends(D.oid) AS numbackends, \
            pg_stat_get_db_xact_commit(D.oid) AS xact_commit, \
            pg_stat_get_db_xact_rollback(D.oid) AS xact_rollback, \
            pg_stat_get_db_blocks_fetched(D.oid) - \
                    pg_stat_get_db_blocks_hit(D.oid) AS blks_read, \
            pg_stat_get_db_blocks_hit(D.oid) AS blks_hit \
    FROM pg_database D;

EOF
if [ "$?" -ne 0 ]; then
    exit_nicely
fi
947
echo "ok"
948

949
$ECHO_N "loading pg_description... "$ECHO_C
950
(
951 952 953 954 955 956 957 958
  cat <<EOF
    CREATE TEMP TABLE tmp_pg_description ( \
	objoid oid, \
	classname name, \
	objsubid int4, \
	description text) WITHOUT OIDS;
    COPY tmp_pg_description FROM STDIN;
EOF
959
  cat "$POSTGRES_DESCR"
960 961 962 963 964 965
  cat <<EOF
\.
    INSERT INTO pg_description SELECT \
	t.objoid, c.oid, t.objsubid, t.description \
    FROM tmp_pg_description t, pg_class c WHERE c.relname = t.classname;
EOF
966
) \
967
	| "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
968
echo "ok"
969

970 971 972 973 974 975 976 977 978
# Set most system catalogs and built-in functions as world-accessible.
# Some objects may require different permissions by default, so we
# make sure we don't overwrite privilege sets that have already been
# set (NOT NULL).
$ECHO_N "setting privileges on built-in objects... "$ECHO_C
(
  cat <<EOF
    UPDATE pg_class SET relacl = '{"=r"}' \
        WHERE relkind IN ('r', 'v', 'S') AND relacl IS NULL;
979
    UPDATE pg_proc SET proacl = '{"=X"}' \
980
        WHERE proacl IS NULL;
981
    UPDATE pg_language SET lanacl = '{"=U"}' \
982 983 984 985 986 987
        WHERE lanpltrusted;
EOF
) \
	| "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
echo "ok"

988
$ECHO_N "vacuuming database template1... "$ECHO_C
989 990

"$PGPATH"/postgres $PGSQL_OPT template1 >/dev/null <<EOF
991
VACUUM FULL FREEZE;
992 993 994 995
EOF
if [ "$?" -ne 0 ]; then
    exit_nicely
fi
996
echo "ok"
997

998
$ECHO_N "copying template1 to template0... "$ECHO_C
999 1000 1001

"$PGPATH"/postgres $PGSQL_OPT template1 >/dev/null <<EOF
CREATE DATABASE template0;
1002

1003
UPDATE pg_database SET \
1004 1005
	datistemplate = 't', \
	datallowconn = 'f' \
1006
    WHERE datname = 'template0';
1007 1008 1009 1010 1011 1012

-- We use the OID of template0 to determine lastsysoid

UPDATE pg_database SET datlastsysoid = \
    (SELECT oid - 1 FROM pg_database WHERE datname = 'template0');

1013 1014 1015 1016 1017
VACUUM FULL pg_database;
EOF
if [ "$?" -ne 0 ]; then
    exit_nicely
fi
1018
echo "ok"
1019

1020 1021 1022 1023 1024

##########################################################################
#
# FINISHED

1025
echo
1026
echo "Success. You can now start the database server using:"
1027
echo ""
1028
echo "    $PGPATH/postmaster -D $PGDATA"
1029
echo "or"
1030 1031 1032
# (Advertise -l option here, otherwise we have a background
#  process writing to the terminal.)
echo "    $PGPATH/pg_ctl -D $PGDATA -l logfile start"
1033 1034 1035
echo

exit 0